(******************************************************************************
 *                             Core-extended                                  *
 *                                                                            *
 * Copyright (C) 2008- Jane Street Holding, LLC                               *
 *    Contact: opensource@janestreet.com                                      *
 *    WWW: http://www.janestreet.com/ocaml                                    *
 *                                                                            *
 *                                                                            *
 * This library is free software; you can redistribute it and/or              *
 * modify it under the terms of the GNU Lesser General Public                 *
 * License as published by the Free Software Foundation; either               *
 * version 2 of the License, or (at your option) any later version.           *
 *                                                                            *
 * This library is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 * Lesser General Public License for more details.                            *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public           *
 * License along with this library; if not, write to the Free Software        *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 *                                                                            *
 ******************************************************************************)

type t = 
  | Realtime
  | Monotonic
  | Process_cpu
  | Process_thread

val all : t list

val to_string : t -> string

(* returns the resulution of the given clock in nanoseconds *)
val getres : t -> int

(* returns the current value of the given clock in nanoseconds *)
val gettime : t -> int

(* sleeps the current thread for the specified number of nanoseconds *)
(*val nanosleep : t -> int -> unit*)

(* [min_interval t] returns the minimum measurable interval for t in nanoseconds *)
val min_interval : t -> int

(* [cost t] returns the cost of calling gettime with the given t int nanoseconds *)
val mean_gettime_cost : measure:t -> using:t -> int
